-- Oracle script for the creation of sample tables and data
create table product (
    product_id       number(10,0) not null,
    product_type_id  number(10,0) not null,
    product_name     varchar2(20) not null,
    parent_product_id number(10,0) null,
    constraint product_pk primary key (product_id)
);

create table product_type (
    product_type_id   number(10,0) not null,
    product_type_name varchar2(20) not null,
    constraint product_type_pk primary key (product_type_id)
);

create table product_additional (
    product_id number(10,0) not null,
    name1      varchar2(20) null,
    name2      varchar2(20) null,
    name3      varchar2(20) null
);

alter table PRODUCT add constraint parent_product_fk
    foreign key (parent_product_id) references product (product_id);

alter table PRODUCT add constraint prodtype_product_fk
    foreign key (product_type_id) references product_type (product_type_id);

insert into product_type (product_type_id, product_type_name) values (100, 'Group A Products');
insert into product_type (product_type_id, product_type_name) values (200, 'Group B Products');
insert into product_type (product_type_id, product_type_name) values (300, 'Group C Products');
insert into product_type (product_type_id, product_type_name) values (400, 'Group D Products');
insert into product_type (product_type_id, product_type_name) values (500, 'Group E Products');

insert into product (product_id, product_type_id, product_name, parent_product_id) values ( 1, 100, 'Product A', null);
insert into product (product_id, product_type_id, product_name, parent_product_id) values ( 2, 200, 'Product B', null);

insert into product (product_id, product_type_id, product_name, parent_product_id) values ( 3, 300, 'Product C1', 1);
insert into product (product_id, product_type_id, product_name, parent_product_id) values ( 4, 300, 'Product C2', 1);
insert into product (product_id, product_type_id, product_name, parent_product_id) values ( 5, 300, 'Product C3', 1);

insert into product (product_id, product_type_id, product_name, parent_product_id) values ( 6, 400, 'Product D1', 2);
insert into product (product_id, product_type_id, product_name, parent_product_id) values ( 7, 400, 'Product D2', 2);

insert into product (product_id, product_type_id, product_name, parent_product_id) values ( 8, 500, 'Product E1', 6);
insert into product (product_id, product_type_id, product_name, parent_product_id) values ( 9, 500, 'Product E2', 6);
insert into product (product_id, product_type_id, product_name, parent_product_id) values (10, 500, 'Product E3', 7);

insert into product_additional (product_id, name1, name2, name3) values (1, 'value11', null, null);
insert into product_additional (product_id, name1, name2, name3) values (2, 'value21', 'value212', 'value213');
insert into product_additional (product_id, name1, name2, name3) values (3, 'value31', null, 'value313');
insert into product_additional (product_id, name1, name2, name3) values (3, 'value32', 'value322', 'value323');

commit;

